package se.hig.estates.v2;

import java.util.List;

import se.hig.nrts.State;
import se.sics.prologbeans.PBTerm;

public class Estate {
	private static final String PERSON_FUNCTOR = "person";
	private static final String ESTATE_FUNCTOR = "estate";
	private static final String ADJ_FUNCTOR = "adjacent";
	
	private String name;
	private String owner;
	private String mainBuilding;
	private String cows;
	private String fence;
	
	public Estate(String name, String owner, String mainBuilding, String cows,
			String fence) {
		super();
		this.name = name;
		this.owner = owner;
		this.mainBuilding = mainBuilding;
		this.cows = cows;
		this.fence = fence;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getOwner() {
		return owner;
	}
	public void setOwner(String owner) {
		this.owner = owner;
	}
	public String getMainBuilding() {
		return mainBuilding;
	}
	public void setMainBuilding(String mainBuilding) {
		this.mainBuilding = mainBuilding;
	}
	public String getCows() {
		return cows;
	}
	public void setCows(String cows) {
		this.cows = cows;
	}
	public String getFence() {
		return fence;
	}
	public void setFence(String fence) {
		this.fence = fence;
	}
	
//	public static PBTerm createPersonTerm(String agentID) {
//		PBTerm [] arguments = { 
//				PBTerm.makeAtom(agentID)
//		};
//		PBTerm stateItemTerm = PBTerm.makeTerm(PERSON_FUNCTOR,arguments);
//		return stateItemTerm;
//	}

	public static PBTerm createEstateTerm(String name, String ownerID, String mainBuilding,
			String cows, String fenced) {
		PBTerm [] arguments = { 
				PBTerm.makeAtom(name),
				PBTerm.makeAtom(ownerID),
				PBTerm.makeAtom(mainBuilding),
				PBTerm.makeAtom(cows),
				PBTerm.makeAtom(fenced)
		};
		PBTerm stateItemTerm = PBTerm.makeTerm(ESTATE_FUNCTOR,arguments);
		return stateItemTerm;
	}
	
	public static Estate createEstate(PBTerm estateTerm) {
		String name = estateTerm.getArgument(1).getName();
		String agent = estateTerm.getArgument(2).getName();
		String mainBuilding = estateTerm.getArgument(3).getName();
		String cows = estateTerm.getArgument(4).getName();
		String fenced = estateTerm.getArgument(5).getName();
		return new Estate(name,agent,mainBuilding,cows,fenced);
	}
//	public static PBTerm createAdjacencyTerm(String e1, String e2) {
//		PBTerm [] arguments = { 
//				PBTerm.makeAtom(e1),
//				PBTerm.makeAtom(e2)
//		};
//		PBTerm stateItemTerm = PBTerm.makeTerm(ADJ_FUNCTOR,arguments);
//		return stateItemTerm;
//	}
	
//	public static String getPerson(PBTerm stateTerm) {
//		if(stateTerm.getName().equals(PERSON_FUNCTOR))
//			return stateTerm.getArgument(1).getName();
//		return null;
//	}
	
	public static boolean containsStrayCattle(String estateName, State state) {
		List<PBTerm> estateTermList = State.createStateTermList(state);
		for(PBTerm estateTerm : estateTermList) {
			Estate estate = createEstate(estateTerm);
			if(estateName.equals(estate.getName()))
				return (estate.getCows().equals("cows_from_whiteacre_and_blackacre"));
		}
		return false;
	}
}
