/*
 * Copyright 2013 Magnus Hjelmblom, University of Gvle, Sweden
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package se.hig.nrts;

import java.io.IOException;
import java.util.List;

import se.hig.nrts.PrologSessionHandler;

public abstract class GenericComponent {
	public static final String MOD_USER = "user";
	public static final String MOD_NRTS = "nrts";
	public static final String NRTS_SIT = "nrts_sit";
	public static final String EMPTY = "empty";
	public static final String EMPTY_GCSET = "empty_gc_set";
	public static final String ADD_TO_GCSET = "add_to_gc_set";
	public static final String REMOVE_FIRST_FROM_GCSET = "remove_first_from_gc_set";
	public static final String ACT_RESULT = "act_result";
	public static final String PERMISSIBLE_ACT = "permissible_act";
	public static final String PERMISSIBLE_ACTS = "permissible_acts";
	public static final String NORM_SYSTEM = "ns";
	public static final String NORM = "n";
	public static final String AND = "&";
	public static final String OR = ";";
	public static final String NOT = "not";

	protected static PrologSessionHandler prologSessionHandler = 
		PrologSessionHandler.getInstance();

	protected static void connect() throws IOException {
//		System.out.print("* Connecting... ");
		prologSessionHandler.getSession().connect();
//		System.out.println("Done!");		
	}

	protected static void disconnect() {
//		System.out.print("* Disconnecting... ");
		prologSessionHandler.getSession().disconnect();
//		System.out.println("Done!");		
	}
	
	protected static boolean isBooleanConnective(String name) {
		return (isNegation(name)||isBinaryBooleanConnective(name));
	}
	
	protected static boolean isBinaryBooleanConnective(String name) {
		return (AND.equals(name)||OR.equals(name));	}

	protected static boolean isNegation(String name) {
		return (NOT.equals(name));
	}

	protected static String toString(String [] strings) {
		StringBuffer stringBuffer = new StringBuffer();
		int i;
		for(i=0; i<strings.length-1; i++) {
			stringBuffer.append(strings[i]+",");
		}
		stringBuffer.append(strings[i]);
		return stringBuffer.toString();
	}
	
	public static String toString(List objects) {
		StringBuffer stateSBuf = new StringBuffer();
		for (Object object : objects) {
			stateSBuf.append(object.toString() + "\n");
		}
		return stateSBuf.toString();
	}

}
