/*
 * Copyright 2013 Magnus Hjelmblom, University of Gvle, Sweden
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package se.hig.nrts.client;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import se.hig.nrts.exceptions.NRTSException;

public class AddActFrame extends JFrame {
	private NRTSClientPanel parent;
	private JLabel actIDLabel = new JLabel("Act ID");
	private JPanel centerPanel = new JPanel();
	private JTextField actIDTxt = new JTextField();
	private JTextField actParameterTxt = new JTextField();
	private JButton addActBtn = new JButton("Add act");
	
	public AddActFrame(NRTSClientPanel parent) {
		super("Add act");
		this.parent = parent;
		initFrame();
	}

	private void initFrame() {
		this.setLayout(new BorderLayout());
		// --- CENTER PANEL ---
		centerPanel.setLayout(new BoxLayout(centerPanel, BoxLayout.Y_AXIS));
		centerPanel.add(actIDLabel);
		centerPanel.add(actIDTxt);
		centerPanel.add(actParameterTxt);
		
		// --- MAIN FRAME ---		
		this.add(centerPanel, BorderLayout.CENTER);
		addActBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				String actID = actIDTxt.getText();
				String actParameterString = actParameterTxt.getText();
				try {
					parent.addAct(actID,actParameterString);
				} catch (NRTSException ne) {
					JOptionPane.showMessageDialog(centerPanel, 
							ne.getMessage(),"ERROR",JOptionPane.ERROR_MESSAGE);					
				}
				AddActFrame.this.dispose();
			}
		});
		this.add(addActBtn, BorderLayout.SOUTH);
		this.pack();
	}

}
