/*
 * Copyright 2013 Magnus Hjelmblom, University of Gvle, Sweden
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package se.hig.nrts.norms;

public class MoveOperator extends Operator {
	public static final String MOVE = "move";
	public static final MoveOperator M0 = (MoveOperator)createOperator(MOVE,"0");
	public static final MoveOperator M1 = (MoveOperator)createOperator(MOVE,"1");
	public static final MoveOperator M2 = (MoveOperator)createOperator(MOVE,"2");
	public static final MoveOperator M = M0; // M is an alias for M0
	
	public static final Operator [] MOVE_OPS = { M0,M1,M2 };
	
	public MoveOperator() {
		super(MOVE,"0");
	}
	
	public MoveOperator(String parameter) {
		super(MOVE,parameter);
	}

}
