/*
 * Copyright 2013 Magnus Hjelmblom, University of Gvle, Sweden
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package se.hig.nrts.norms;

import se.hig.nrts.GenericComponent;

public class Norm extends GenericComponent {
	protected String normID;
	protected Ground ground;
	protected Consequence consequence;

	/**
	 * @param normID
	 * @param consequence
	 * @param ground
	 */
	protected Norm(String normID, Ground ground, Consequence consequence) {
		this.normID = normID;
		this.ground = ground;
		this.consequence = consequence;
	}

	/**
	 * @return the consequence
	 */
	public Consequence getConsequence() {
		return consequence;
	}

	/**
	 * @return the ground
	 */
	public Ground getGround() {
		return ground;
	}

	/**
	 * @return the normID
	 */
	public String getNormID() {
		return normID;
	}

	
	/* (non-Javadoc)
	 * @see se.hig.jdalmas.norms.Norm#isElementary()
	 */
	public boolean isElementary() {
		return (ground.isElementary()&&consequence.isElementary());
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return normID + ":<" + ground.toString() + "," + consequence.toString() + ">";
	}

}