/*
 * Copyright 2013 Magnus Hjelmblom, University of Gvle, Sweden
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package se.hig.nrts.norms;

public class TypeOperator extends Operator {
	public static final String TYPE = "p";
	public static final TypeOperator P1 = (TypeOperator)createOperator(TYPE,"1");
	public static final TypeOperator P21 = (TypeOperator)createOperator(TYPE,"21");
	public static final TypeOperator P22 = (TypeOperator)createOperator(TYPE,"22");
	public static final TypeOperator P41 = (TypeOperator)createOperator(TYPE,"41");
	public static final TypeOperator P42 = (TypeOperator)createOperator(TYPE,"42");
	public static final TypeOperator P5 = (TypeOperator)createOperator(TYPE,"5");
	public static final TypeOperator P61 = (TypeOperator)createOperator(TYPE,"61");
	public static final TypeOperator P62 = (TypeOperator)createOperator(TYPE,"62");
	public static final TypeOperator P7 = (TypeOperator)createOperator(TYPE,"7");

	public static final Operator [] TYPE_OPS = { 
		P1,P21,P22,P41,P42,P5,P61,P62,P7 };
	
	public TypeOperator(String parameter) {
		super(TYPE,parameter);
	}

}
